/*
 * 2014/12 made by audin
 * http://mpu.seesaa.net
 *
 */
#include "uart.h"
#include "xprintf.h"

static UART_MODULE udev;

/****************************/
/* __putchar
 ****************************/
void _MIPS16 __putchar( unsigned char ch )
{
    uart_send_byte( udev, &ch );
}

/****************************/
/* uart_init
 ****************************/
void _MIPS16 uart_init( UART_MODULE dev, uint32_t baudrate)
{
    udev = dev;
    U1RXRbits.U1RXR = 4; //SET RX to RPB2 , pin6
    RPB3Rbits.RPB3R = 1; //SET RPB3R to TX, pin7
    PORTSetPinsDigitalIn(IOPORT_B, BIT_2);

    UARTConfigure(dev, UART_ENABLE_PINS_TX_RX_ONLY);
    //UARTSetFifoMode(dev, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(dev, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(dev, GetPeripheralClock(), baudrate);
    UARTEnable(dev, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));

    xdev_out( __putchar );
}

/****************************/
/* uart_send
 ****************************/
void _MIPS16 uart_send(UART_MODULE dev, const char *buf, uint32_t size)
{
    while(size) {
        while( !UARTTransmitterIsReady( dev ) ){ /* wait */ }
        UARTSendDataByte( dev, *buf );
        buf++;
        size--;
    }

    //while( !UARTTransmissionHasCompleted( dev ) ) ;
}
bool _MIPS16 uart1_rx_data_available(void)
{
    return UARTReceivedDataIsAvailable( UART1 );
}

uint8_t _MIPS16 uart1_getchar(void)
{
    return UARTGetDataByte( UART1 );

}
